use clap::Parser;
use tool_helper::{Error, exit_with_error};
use std::path::PathBuf;

#[derive(Parser)]
#[clap(about = "Opens and scans a MAP file to print extended information", long_about = None)]
struct CommandLine {
    #[clap(value_parser, help="Input MAP file for scannning")]
    input:          Option<PathBuf>
}

fn run_main(cmd: CommandLine) -> Result<(), Error> {
    let _sections = readmap::scan(tool_helper::open_input(cmd.input)?)?;

    println!("Found sections!");
    Ok(())
}

pub fn main() {
    match CommandLine::try_parse() {
        Ok(cmd_line) => {
            match run_main(cmd_line) {
                Ok(_)      => (),
                Err(error) => exit_with_error(error)
            }
        },
        Err(error) => {
            println!("{}", error)
        }
    }
}